Index: trunk/sources/HeuristicLab.sln
===================================================================
--- trunk/sources/HeuristicLab.sln	(revision 1923)
+++ trunk/sources/HeuristicLab.sln	(revision 1924)
@@ -2348,4 +2348,5 @@
 		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C}.v3.2 Debug|x64.ActiveCfg = Debug|x64
 		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C}.v3.2 Debug|x86.ActiveCfg = Debug|x86
+		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{CE2DFB48-6A9C-4507-96C6-5FC40E92035C}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -2915,4 +2916,5 @@
 		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}.v3.2 Debug|x64.ActiveCfg = Debug|x64
 		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}.v3.2 Debug|x86.ActiveCfg = Debug|x86
+		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3391,4 +3393,5 @@
 		{E3288D4B-7A51-499A-AC5B-019319CE51DC}.v3.2 Debug|x64.ActiveCfg = Debug|x64
 		{E3288D4B-7A51-499A-AC5B-019319CE51DC}.v3.2 Debug|x86.ActiveCfg = Debug|x86
+		{E3288D4B-7A51-499A-AC5B-019319CE51DC}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{E3288D4B-7A51-499A-AC5B-019319CE51DC}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{E3288D4B-7A51-499A-AC5B-019319CE51DC}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3454,5 +3457,5 @@
 		{7E18E25A-BCEB-467A-BACC-ABCA73F9D655}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
 		{7E18E25A-BCEB-467A-BACC-ABCA73F9D655}.v3.2 Debug|x64.ActiveCfg = Debug|Any CPU
-		{7E18E25A-BCEB-467A-BACC-ABCA73F9D655}.v3.2 Debug|x86.ActiveCfg = Debug|Any CPU
+		{7E18E25A-BCEB-467A-BACC-ABCA73F9D655}.v3.2 Debug|x86.ActiveCfg = Debug|x86
 		{7E18E25A-BCEB-467A-BACC-ABCA73F9D655}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{7E18E25A-BCEB-467A-BACC-ABCA73F9D655}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3482,5 +3485,6 @@
 		{A16F23B5-FB62-499E-A831-26953AA56FE2}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
 		{A16F23B5-FB62-499E-A831-26953AA56FE2}.v3.2 Debug|x64.ActiveCfg = Debug|Any CPU
-		{A16F23B5-FB62-499E-A831-26953AA56FE2}.v3.2 Debug|x86.ActiveCfg = Debug|Any CPU
+		{A16F23B5-FB62-499E-A831-26953AA56FE2}.v3.2 Debug|x86.ActiveCfg = Debug|x86
+		{A16F23B5-FB62-499E-A831-26953AA56FE2}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{A16F23B5-FB62-499E-A831-26953AA56FE2}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{A16F23B5-FB62-499E-A831-26953AA56FE2}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3511,5 +3515,6 @@
 		{80F7FADA-549D-4151-8856-79B620A50DBA}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
 		{80F7FADA-549D-4151-8856-79B620A50DBA}.v3.2 Debug|x64.ActiveCfg = Debug|Any CPU
-		{80F7FADA-549D-4151-8856-79B620A50DBA}.v3.2 Debug|x86.ActiveCfg = Debug|Any CPU
+		{80F7FADA-549D-4151-8856-79B620A50DBA}.v3.2 Debug|x86.ActiveCfg = Debug|x86
+		{80F7FADA-549D-4151-8856-79B620A50DBA}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{80F7FADA-549D-4151-8856-79B620A50DBA}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{80F7FADA-549D-4151-8856-79B620A50DBA}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3545,5 +3550,4 @@
 		{EE956A95-6344-4B01-876F-BE95C5E2F92B}.v3.2 Debug|x64.Build.0 = Debug|x64
 		{EE956A95-6344-4B01-876F-BE95C5E2F92B}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{EE956A95-6344-4B01-876F-BE95C5E2F92B}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{EE956A95-6344-4B01-876F-BE95C5E2F92B}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{EE956A95-6344-4B01-876F-BE95C5E2F92B}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3581,5 +3585,4 @@
 		{72908B54-D136-4BF2-8474-25AA6CB66C92}.v3.2 Debug|x64.Build.0 = Debug|x64
 		{72908B54-D136-4BF2-8474-25AA6CB66C92}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{72908B54-D136-4BF2-8474-25AA6CB66C92}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{72908B54-D136-4BF2-8474-25AA6CB66C92}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{72908B54-D136-4BF2-8474-25AA6CB66C92}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3617,5 +3620,4 @@
 		{6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6}.v3.2 Debug|x64.Build.0 = Debug|x64
 		{6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3653,5 +3655,4 @@
 		{81609E8A-9757-4865-8B89-0B6603F769E8}.v3.2 Debug|x64.Build.0 = Debug|x64
 		{81609E8A-9757-4865-8B89-0B6603F769E8}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{81609E8A-9757-4865-8B89-0B6603F769E8}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{81609E8A-9757-4865-8B89-0B6603F769E8}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{81609E8A-9757-4865-8B89-0B6603F769E8}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3689,5 +3690,4 @@
 		{4C3305C4-E440-4EAD-B218-68D77AE51543}.v3.2 Debug|x64.Build.0 = Debug|x64
 		{4C3305C4-E440-4EAD-B218-68D77AE51543}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{4C3305C4-E440-4EAD-B218-68D77AE51543}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{4C3305C4-E440-4EAD-B218-68D77AE51543}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{4C3305C4-E440-4EAD-B218-68D77AE51543}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3725,5 +3725,4 @@
 		{55E23C37-F4F8-4B20-89B3-1B8B59050CE2}.v3.2 Debug|x64.Build.0 = Debug|x64
 		{55E23C37-F4F8-4B20-89B3-1B8B59050CE2}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{55E23C37-F4F8-4B20-89B3-1B8B59050CE2}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{55E23C37-F4F8-4B20-89B3-1B8B59050CE2}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{55E23C37-F4F8-4B20-89B3-1B8B59050CE2}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3761,5 +3760,4 @@
 		{C2E99CCE-9FB0-456F-9BA0-57900E4AA799}.v3.2 Debug|x64.Build.0 = Debug|x64
 		{C2E99CCE-9FB0-456F-9BA0-57900E4AA799}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{C2E99CCE-9FB0-456F-9BA0-57900E4AA799}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{C2E99CCE-9FB0-456F-9BA0-57900E4AA799}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{C2E99CCE-9FB0-456F-9BA0-57900E4AA799}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3797,5 +3795,4 @@
 		{BEE2B944-7F12-42CC-95A0-6EFB837FDA00}.v3.2 Debug|x64.Build.0 = Debug|x64
 		{BEE2B944-7F12-42CC-95A0-6EFB837FDA00}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{BEE2B944-7F12-42CC-95A0-6EFB837FDA00}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{BEE2B944-7F12-42CC-95A0-6EFB837FDA00}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{BEE2B944-7F12-42CC-95A0-6EFB837FDA00}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3825,5 +3822,6 @@
 		{ABAE70E0-14E3-4588-B6BB-15DF022985C3}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
 		{ABAE70E0-14E3-4588-B6BB-15DF022985C3}.v3.2 Debug|x64.ActiveCfg = Debug|Any CPU
-		{ABAE70E0-14E3-4588-B6BB-15DF022985C3}.v3.2 Debug|x86.ActiveCfg = Debug|Any CPU
+		{ABAE70E0-14E3-4588-B6BB-15DF022985C3}.v3.2 Debug|x86.ActiveCfg = Debug|x86
+		{ABAE70E0-14E3-4588-B6BB-15DF022985C3}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{ABAE70E0-14E3-4588-B6BB-15DF022985C3}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{ABAE70E0-14E3-4588-B6BB-15DF022985C3}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3859,5 +3857,4 @@
 		{6AD536AE-B4CC-4424-B0A2-20CECE88CE57}.v3.2 Debug|x64.Build.0 = Debug|x64
 		{6AD536AE-B4CC-4424-B0A2-20CECE88CE57}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{6AD536AE-B4CC-4424-B0A2-20CECE88CE57}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{6AD536AE-B4CC-4424-B0A2-20CECE88CE57}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{6AD536AE-B4CC-4424-B0A2-20CECE88CE57}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3895,5 +3892,4 @@
 		{DA0D505A-2149-4E3C-B220-5724DE26EB59}.v3.2 Debug|x64.Build.0 = Debug|x64
 		{DA0D505A-2149-4E3C-B220-5724DE26EB59}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{DA0D505A-2149-4E3C-B220-5724DE26EB59}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{DA0D505A-2149-4E3C-B220-5724DE26EB59}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{DA0D505A-2149-4E3C-B220-5724DE26EB59}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3931,5 +3927,4 @@
 		{4BA6068B-647C-454D-AED1-F4833034A476}.v3.2 Debug|x64.Build.0 = Debug|x64
 		{4BA6068B-647C-454D-AED1-F4833034A476}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{4BA6068B-647C-454D-AED1-F4833034A476}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{4BA6068B-647C-454D-AED1-F4833034A476}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{4BA6068B-647C-454D-AED1-F4833034A476}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3967,5 +3962,4 @@
 		{3A5ACA94-47A7-47D6-B644-2B8A7503FCCC}.v3.2 Debug|x64.Build.0 = Debug|x64
 		{3A5ACA94-47A7-47D6-B644-2B8A7503FCCC}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{3A5ACA94-47A7-47D6-B644-2B8A7503FCCC}.v3.2 Debug|x86.Build.0 = Debug|x86
 		{3A5ACA94-47A7-47D6-B644-2B8A7503FCCC}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{3A5ACA94-47A7-47D6-B644-2B8A7503FCCC}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU