Index: trunk/sources/HeuristicLab.Constraints/3.2/HeuristicLabConstraintsPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.Constraints/3.2/HeuristicLabConstraintsPlugin.cs	(revision 1926)
+++ trunk/sources/HeuristicLab.Constraints/3.2/HeuristicLabConstraintsPlugin.cs	(revision 1927)
@@ -33,5 +33,4 @@
   [Dependency(Dependency = "HeuristicLab.Core-3.2")]
   [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
   public class HeuristicLabConstraintsPlugin : PluginBase {
   }
Index: trunk/sources/HeuristicLab.DataAnalysis/3.2/HeuristicLabDataAnalysisPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.DataAnalysis/3.2/HeuristicLabDataAnalysisPlugin.cs	(revision 1926)
+++ trunk/sources/HeuristicLab.DataAnalysis/3.2/HeuristicLabDataAnalysisPlugin.cs	(revision 1927)
@@ -30,4 +30,5 @@
   [Dependency(Dependency = "HeuristicLab.Core-3.2")]
   [Dependency(Dependency = "HeuristicLab.Data-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Random-3.2")]
   public class HeuristicLabDataAnalysisPlugin : PluginBase {
   }
Index: trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/HeuristicLabGPStructureIdentificationPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/HeuristicLabGPStructureIdentificationPlugin.cs	(revision 1926)
+++ trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/HeuristicLabGPStructureIdentificationPlugin.cs	(revision 1927)
@@ -35,4 +35,5 @@
   [Dependency(Dependency = "HeuristicLab.GP-3.3")]
   [Dependency(Dependency = "HeuristicLab.Logging-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Modeling-3.2")]
   [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
   [Dependency(Dependency = "HeuristicLab.Operators.Programmable-3.2")]
@@ -41,5 +42,4 @@
   [Dependency(Dependency = "HeuristicLab.Selection.OffspringSelection-3.2")]
   [Dependency(Dependency = "HeuristicLab.SequentialEngine-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Modeling-3.2")]
   public class HeuristicLabGPStructureIdentificationPlugin : PluginBase {
   }
Index: trunk/sources/HeuristicLab.Hive.Contracts/3.2/HiveContractPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/3.2/HiveContractPlugin.cs	(revision 1926)
+++ trunk/sources/HeuristicLab.Hive.Contracts/3.2/HiveContractPlugin.cs	(revision 1927)
@@ -29,4 +29,5 @@
   [PluginFile(Filename = "HeuristicLab.Hive.Contracts-3.2.dll", Filetype = PluginFileType.Assembly)]
   [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Dependency(Dependency = "HeuristicLab.DataAccess-3.2")]
   public class HiveServerContracts : PluginBase {
   }
Index: trunk/sources/HeuristicLab.Hive.Engine/3.2/HeuristicLabHiveEnginePlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Engine/3.2/HeuristicLabHiveEnginePlugin.cs	(revision 1926)
+++ trunk/sources/HeuristicLab.Hive.Engine/3.2/HeuristicLabHiveEnginePlugin.cs	(revision 1927)
@@ -32,4 +32,7 @@
   [PluginFile(Filename = "HeuristicLab.Hive.Engine-3.2.dll", Filetype = PluginFileType.Assembly)]
   [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
+  [Dependency(Dependency = "HeuristicLab.DataAccess-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Hive.Contracts-3.2")]
   [Dependency(Dependency = "HeuristicLab.Hive.JobBase-3.2")]
   [Dependency(Dependency = "HeuristicLab.SequentialEngine-3.2")]
Index: trunk/sources/HeuristicLab.Logging/3.2/HeuristicLabLoggingPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.Logging/3.2/HeuristicLabLoggingPlugin.cs	(revision 1926)
+++ trunk/sources/HeuristicLab.Logging/3.2/HeuristicLabLoggingPlugin.cs	(revision 1927)
@@ -31,9 +31,9 @@
   [ClassInfo(Name = "HeuristicLab.Logging-3.2")]
   [PluginFile(Filename = "HeuristicLab.Logging-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Dependency(Dependency = "HeuristicLab.Charting-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Charting.Data-3.2")]
   [Dependency(Dependency = "HeuristicLab.Core-3.2")]
   [Dependency(Dependency = "HeuristicLab.Data-3.2")]
   [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Charting-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Charting.Data-3.2")]
   public class HeuristicLabLoggingPlugin : PluginBase {
   }
Index: trunk/sources/HeuristicLab.Modeling/3.2/HeuristicLabModelingPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.Modeling/3.2/HeuristicLabModelingPlugin.cs	(revision 1926)
+++ trunk/sources/HeuristicLab.Modeling/3.2/HeuristicLabModelingPlugin.cs	(revision 1927)
@@ -28,4 +28,7 @@
   [ClassInfo(Name = "HeuristicLab.Modeling-3.2")]
   [PluginFile(Filename = "HeuristicLab.Modeling-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
+  [Dependency(Dependency = "HeuristicLab.DataAnalysis-3.2")]
   public class HeuristicLabModelingPlugin : PluginBase {
   }
Index: trunk/sources/HeuristicLab.Operators/3.2/HeuristicLabOperatorsPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.2/HeuristicLabOperatorsPlugin.cs	(revision 1926)
+++ trunk/sources/HeuristicLab.Operators/3.2/HeuristicLabOperatorsPlugin.cs	(revision 1927)
@@ -31,4 +31,5 @@
   [ClassInfo(Name = "HeuristicLab.Operators-3.2")]
   [PluginFile(Filename = "HeuristicLab.Operators-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Dependency(Dependency = "HeuristicLab.Constraints-3.2")]
   [Dependency(Dependency = "HeuristicLab.Core-3.2")]
   [Dependency(Dependency = "HeuristicLab.Data-3.2")]
Index: trunk/sources/HeuristicLab.Random/3.2/HeuristicLabRandomPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.Random/3.2/HeuristicLabRandomPlugin.cs	(revision 1926)
+++ trunk/sources/HeuristicLab.Random/3.2/HeuristicLabRandomPlugin.cs	(revision 1927)
@@ -31,4 +31,5 @@
   [ClassInfo(Name = "HeuristicLab.Random-3.2")]
   [PluginFile(Filename = "HeuristicLab.Random-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Dependency(Dependency = "HeuristicLab.Constraints-3.2")]
   [Dependency(Dependency = "HeuristicLab.Core-3.2")]
   [Dependency(Dependency = "HeuristicLab.Data-3.2")]