Index: trunk/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/Job.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/Job.cs	(revision 1931)
+++ trunk/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/Job.cs	(revision 1932)
@@ -56,4 +56,6 @@
     [DataMember]
     public List<HivePluginInfo> PluginsNeeded { get; set; }
+    [DataMember]
+    public List<ClientGroup> ClientGroups { get; set; }
 
     public Job() {
Index: trunk/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/Project.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/Project.cs	(revision 1932)
+++ trunk/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/Project.cs	(revision 1932)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Runtime.Serialization;
+using HeuristicLab.DataAccess;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Hive.Contracts.BusinessObjects {
+
+  [DataContract]
+  public class Project : PersistableObject {
+    [DataMember]
+    public String Name { get; set; }
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Contracts/3.2/HeuristicLab.Hive.Contracts-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/3.2/HeuristicLab.Hive.Contracts-3.2.csproj	(revision 1931)
+++ trunk/sources/HeuristicLab.Hive.Contracts/3.2/HeuristicLab.Hive.Contracts-3.2.csproj	(revision 1932)
@@ -89,4 +89,5 @@
     <Compile Include="BusinessObjects\CachedHivePluginInfo.cs" />
     <Compile Include="BusinessObjects\ClientGroup.cs" />
+    <Compile Include="BusinessObjects\Project.cs" />
     <Compile Include="BusinessObjects\HivePluginInfo.cs" />
     <Compile Include="BusinessObjects\HeartBeatData.cs" />
Index: trunk/sources/HeuristicLab.Hive.Contracts/3.2/Interfaces/IJobManager.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/3.2/Interfaces/IJobManager.cs	(revision 1931)
+++ trunk/sources/HeuristicLab.Hive.Contracts/3.2/Interfaces/IJobManager.cs	(revision 1932)
@@ -47,4 +47,14 @@
     [OperationContract]
     Response AbortJob(Guid jobId);
+    [OperationContract]
+    ResponseList<Project> GetAllProjects();
+    [OperationContract]
+    Response CreateProject(Project project);
+    [OperationContract]
+    Response ChangeProject(Project project);
+    [OperationContract]
+    Response DeleteProject(Guid projectId);
+    [OperationContract]
+    ResponseList<Job> GetJobsByProject(Guid projectId);
   }
 }
Index: trunk/sources/HeuristicLab.Hive.Server.Core/3.2/JobManager.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/3.2/JobManager.cs	(revision 1931)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/3.2/JobManager.cs	(revision 1932)
@@ -354,5 +354,25 @@
       }
     }
-      
+
+    public ResponseList<Project> GetAllProjects() {
+      throw new NotImplementedException();
+    }
+
+    public Response CreateProject(Project project) {
+      throw new NotImplementedException();
+    }
+
+    public Response ChangeProject(Project project) {
+      throw new NotImplementedException();
+    }
+
+    public Response DeleteProject(Guid projectId) {
+      throw new NotImplementedException();
+    }
+
+    public ResponseList<Job> GetJobsByProject(Guid projectId) {
+      throw new NotImplementedException();
+    }
+
     #endregion
   }
Index: trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs	(revision 1931)
+++ trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs	(revision 1932)
@@ -192,4 +192,25 @@
 
     }
+
+    public ResponseList<Project> GetAllProjects() {
+      return jobManager.GetAllProjects();
+    }
+
+    public Response CreateProject(Project project) {
+      return jobManager.CreateProject(project);
+    }
+
+    public Response ChangeProject(Project project) {
+      return jobManager.ChangeProject(project);
+    }
+
+    public Response DeleteProject(Guid projectId) {
+      return jobManager.DeleteProject(projectId);
+    }
+
+    public ResponseList<Job> GetJobsByProject(Guid projectId) {
+      return jobManager.GetJobsByProject(projectId);
+    }
+
   }
 }